%% 
close all;clear all;clc;
load('20111205-BEADS_DATA-Series002.mat');
T_end = Prop.Td;
%% 
close all;clear all;clc;
load('20111205-BEADS_DATA-Series001.mat');
T_end = Prop.Td;
%%
%% Plot Trajectories between two time points
t1 = 50; t2 = t1 + 250;
figure('position', [50 50 700 700]), hold on,

T_traj_tmp = Sel_Traj_Len(Sel_Traj_T(T_traj, t1, t2), 5);
for i=1:length(T_traj_tmp),
    plot3(T_traj_tmp{i}(:, 1), T_traj_tmp{i}(:, 2), T_traj_tmp{i}(:, 3), 'r', 'linewidth', 1);
end
view([-1 4]);title(['Trajectories between t1 = ' num2str(t1), ' and t2 = ', num2str(t2)]);

%% Create a movie of the flow
close all;
fig = figure('Position', [50 50 700 700]); % create the figure

t_step = 1; t_sel = 3;
numframes = floor(Prop.Td/t_step)-3;
count = 1;
The_Movie = moviein(numframes); % Create the movie variable
set(fig,'NextPlot','replacechildren');

for t = 1:t_step:(t_step*(numframes-1)),
    t1 = t;
    t2 = t+t_sel;
    
    B_traj_cut = Sel_Traj_Len(Sel_Traj_T(T_traj, t1, t2), t_sel);
    
    if isempty(B_traj_cut{1}),
        figure(1), hold off;
        plot([]);
    else
        
        figure(1), hold off;
        
        for i=1:length(B_traj_cut),
            scatter3(B_traj_cut{i}(1,1), B_traj_cut{i}(1,2), B_traj_cut{i}(1,3), 30, 'b', 'filled');
            hold on;
            scatter3(B_traj_cut{i}(end,1), B_traj_cut{i}(end,2), B_traj_cut{i}(end,3), 30, 'g', 'filled');
        end
        
        for i=1:length(B_traj_cut),
            plot3(B_traj_cut{i}(:, 1), B_traj_cut{i}(:, 2), B_traj_cut{i}(:, 3), 'b');
        end
        
        view([-171 4]);axis([0 Prop.Xd*Prop.dx 0 Prop.Yd*Prop.dy 0 Prop.Zd*Prop.dz]);
        title(['Trajectories Between t = ', num2str(t1), ' and t = ', num2str(t2)]);
        drawnow; pause(.1);
    end
   
    The_Movie(count, :) = getframe(figure(1)); 
    count = count + 1;
end
movie2avi(The_Movie, 'My_movie.avi');

%% Create a movie of the flow
close all;
fig = figure('Position', [50 50 700 700]); % create the figure

t_step = 1; t_sel = 5;
numframes = floor(Prop.Td/t_step)-3;
count = 1;
The_Movie = moviein(numframes); % Create the movie variable
set(fig,'NextPlot','replacechildren');

for t = 1:t_step:(t_step*(numframes-1)),
    t1 = t;
    t2 = t+t_sel;
    
    U = []; V = [];
    for i=1:length(T_traj),
        T_pos = T_traj{i}(:, 1:3);
        T_time = T_traj{i}(:, 4);
        
        id1 = find(T_time == t1); id2 = find(T_time == t2);
        if ~isempty(id1) && ~isempty(id2),
            U = [U;T_pos(id1, :)]; V = [V;(T_pos(id2, :)-T_pos(id1, :))];
        end
        
    end
    if isempty(U),
        figure(1), hold off;
        plot([]);
    else
        figure(1), hold off;
        scatter3(U(:, 1), U(:, 2), U(:, 3), 30, 'b', 'filled');hold on;
        quiver3(U(:, 1), U(:, 2), U(:, 3), V(:, 1), V(:, 2), V(:, 3), 0);
        
        view([23 4]);axis([0 Prop.Xd*Prop.dx 0 Prop.Yd*Prop.dy 0 Prop.Zd*Prop.dz]);
        title(['Trajectories Between t = ', num2str(t1), ' and t = ', num2str(t2)]);
        drawnow; pause(.1);
        
        The_Movie(count, :) = getframe(figure(1));
        count = count + 1;
    end
end
movie2avi(The_Movie, 'Beads_flow.avi');
