function S_out = Hessian_Filter(S_in, sigma)
    %G = fspecial('gaussian', [10, 10], sigma);
    G = fspecial('gaussian', sigma);
    S_tmp = S_in;
    for i=1:size(S_in, 3),
        S_tmp(:,:,i) = imfilter(S_in(:,:,i), G);    
    end

    % Calculate Hessian
    Sxx = 2*S_tmp(2:(end-1), 2:(end-1), 2:(end-1)) - ...
        S_tmp(1:(end-2),2:(end-1),2:(end-1)) - S_tmp(3:end,2:(end-1),2:(end-1));

    Syy = 2*S_tmp(2:(end-1),2:(end-1),2:(end-1)) - ...
        S_tmp(2:(end-1),1:(end-2),2:(end-1)) - S_tmp(2:(end-1),3:end,2:(end-1));

    Szz = 2*S_tmp(2:(end-1),2:(end-1),2:(end-1)) - ...
        S_tmp(2:(end-1),2:(end-1),1:(end-2)) - S_tmp(2:(end-1),2:(end-1),3:end);

    % Select regions where the laplacian is zero
    F = (Sxx + Syy + Szz) < 0;
    for i=1:size(F,3),
        %F(:,:,i) = bwmorph(F(:,:,i), 'close', 1);
        F(:,:,i) = bwmorph(bwmorph(F(:,:,i), 'dilate', 1), 'close', 1);
    end

    S_out = S_in(2:(end-1), 2:(end-1), 2:(end-1)).*(~F);
   
end