function varargout = Nucleus_GUI_V2(varargin)
% NUCLEUS_GUI_V2 MATLAB code for Nucleus_GUI_V2.fig
%      NUCLEUS_GUI_V2, by itself, creates a new NUCLEUS_GUI_V2 or raises the existing
%      singleton*.
%
%      H = NUCLEUS_GUI_V2 returns the handle to a new NUCLEUS_GUI_V2 or the handle to
%      the existing singleton*.
%
%      NUCLEUS_GUI_V2('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in NUCLEUS_GUI_V2.M with the given input arguments.
%
%      NUCLEUS_GUI_V2('Property','Value',...) creates a new NUCLEUS_GUI_V2 or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Nucleus_GUI_V2_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Nucleus_GUI_V2_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Nucleus_GUI_V2

% Last Modified by GUIDE v2.5 18-Apr-2014 16:14:46

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Nucleus_GUI_V2_OpeningFcn, ...
                   'gui_OutputFcn',  @Nucleus_GUI_V2_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Nucleus_GUI_V2 is made visible.
function Nucleus_GUI_V2_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Nucleus_GUI_V2 (see VARARGIN)
%{
Nucleus Detection Program 
OLEG POLYAKOV | PRINCETON UNIVERSITY | 2008-2013
This program allows for the manual detection of nucleus in 3-D.
The input for this program is a thresholded stack (X-Y-Z-T) of nucleus
images. It is entered into the handles.imfile path below. One also needs to
enter the parameters of the image, such as the number of Z stacks and the
number of T stakcs.

To generate a thresholded image one usually runs some preprocessing
algorithms on the image, such as a bandpass filter and a gaussian blur
filter. Then a threshold is picked and applied to the image (usually with
ImageJ).

This program allows you to seperate clumps of nulcei by cutting them
manually using the mouse. When the left button of the mouse is pressed, the
mouse will begin to delete pixels from the data allowing you to seperate
them manually. CAREFUL - the image will automatically be saved, so make
sure you have a backup!!
%}
%Enter the filename of the file that you want to process
handles.imfile = [pwd, '\K_DATA\val007_BW.tif'];

% Need to update this for other stacks
handles.Z_max = 24;
handles.T_max = 125;

handles.Stack_all = cell(1,handles.T_max);
handles.BW_all = cell(1, handles.T_max);
handles.N_id = 1;
% Set the sliders
set(handles.T_slider, 'Min', 1);
set(handles.T_slider, 'Max', handles.T_max);
set(handles.T_slider, 'Value', 1);
set(handles.T_slider, 'SliderStep', [1/(handles.T_max-1) 10/(handles.T_max-1)]);

set(handles.Z_slider, 'Min', 1);
set(handles.Z_slider, 'Max', handles.Z_max);
set(handles.Z_slider, 'Value', 1);
set(handles.Z_slider, 'SliderStep', [1/(handles.Z_max-1) 3/(handles.Z_max-1)]);

Plot_stuff;

handles.delete_mode = 0;
set(handles.delete_mode_disp, 'string', 'Delete Mode ON');

handles.hListener_1 = addlistener(handles.N_slider, 'Value','PostSet', @(s, e) plot_things(handles));
handles.hListener_2 = addlistener(handles.Z_slider, 'Value','PostSet', @(s, e) plot_things(handles));
handles.hListener_3 = addlistener(handles.axes1, 'CurrentPoint', 'PostSet', @(s,e) mouseMove(handles));



% Choose default command line output for Nucleus_GUI_V2
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes Nucleus_GUI_V2 wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = Nucleus_GUI_V2_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on slider movement.
function Z_slider_Callback(hObject, eventdata, handles)
% hObject    handle to Z_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function Z_slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Z_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function T_slider_Callback(hObject, eventdata, handles)
% hObject    handle to T_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
delete(handles.hListener_1);
delete(handles.hListener_2);
Plot_stuff;
handles.hListener_1 = addlistener(handles.N_slider, 'Value','PostSet', @(s, e) plot_things(handles));
handles.hListener_2 = addlistener(handles.Z_slider, 'Value','PostSet', @(s, e) plot_things(handles));
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function T_slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to T_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function N_slider_Callback(hObject, eventdata, handles)
% hObject    handle to N_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function N_slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to N_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on button press in Delete_Pix_button.
function Delete_Pix_button_Callback(hObject, eventdata, handles)
% hObject    handle to Delete_Pix_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%set(handles.axes1, 'WindowButtonMotionFcn', @mouseMove);

handles.t = round(get(handles.T_slider, 'Value'));set(handles.T_slider, 'Value', handles.t);
handles.z = round(get(handles.Z_slider, 'Value'));set(handles.Z_slider, 'Value', handles.z);
handles.N_id = round(get(handles.N_slider, 'Value'));set(handles.N_slider, 'Value', handles.N_id);

BW_tmp = handles.BW_all{handles.t};

set(handles.T_disp, 'String', [num2str(handles.t), '/', num2str(handles.T_max)]);
set(handles.Z_disp, 'String', [num2str(handles.z), '/', num2str(handles.Z_max)]);
set(handles.N_disp, 'String', [num2str(handles.N_id), '/', num2str(handles.BW_all{handles.t}.Num)]);
set(handles.N_size, 'String', num2str(BW_tmp.L_sizes(BW_tmp.L_sort(handles.N_id))));

ch = get(handles.axes1, 'Children');

while (1),
    [x, y] = ginput(1);
    if isempty(x), break; end
    handles.Stack((round(y)-1):(round(y)+1), (round(x)-1):(round(x)+1), handles.z) = 0;
    BW_tmp.L((round(y)-1):(round(y)+1), (round(x)-1):(round(x)+1), handles.z) = 0;
    
    handles.Image = zeros(512,512,3);
    handles.Image(:,:,1) = uint8(handles.Stack(:,:,handles.z)/256);
    handles.Image(:,:,2) = (BW_tmp.L(:,:,handles.z) == BW_tmp.L_sort(handles.N_id))*1.0;

    set(ch(1), 'CData', handles.Image);
end

    [L, Num] = bwlabeln(handles.Stack, 6);   
    BW_tmp.L = L;BW_tmp.Num = Num;
    L_sizes = zeros(Num, 1);
    L_non_zero = find(L ~= 0);
    for i=1:length(L_non_zero),
        id = L(L_non_zero(i));
        L_sizes(id) = L_sizes(id) + 1;
    end
    
    [a, b] = sort(L_sizes);
    a = flipud(a); b = flipud(b);
    
    BW_tmp.L_sort = b;
    BW_tmp.L_sizes = L_sizes;
    handles.BW_all{handles.t} = BW_tmp;
    handles.Stack_all{handles.t} = handles.Stack;
    
    set(handles.N_slider, 'Min', 1);
    set(handles.N_slider, 'Max', Num);
    set(handles.N_slider, 'Value', handles.N_id);
    set(handles.N_slider, 'SliderStep', [1/(Num-1) 10/(Num-1)]);
    set(handles.N_disp, 'String', [num2str(handles.N_id), '/', num2str(Num)]);
    set(handles.N_size, 'String', num2str(L_sizes(b(handles.N_id))));

delete(handles.hListener_1);
delete(handles.hListener_2);
handles.hListener_1 = addlistener(handles.N_slider, 'Value','PostSet', @(s, e) plot_things(handles));
handles.hListener_2 = addlistener(handles.Z_slider, 'Value','PostSet', @(s, e) plot_things(handles));

guidata(hObject, handles);


% --- Executes on mouse press over axes background.
function axes1_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to axes1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
disp('Hello');

guidata(hObject, handles);


% --- Executes on mouse motion over figure - except title and menu.
function figure1_WindowButtonMotionFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
xy = round(get(handles.axes1, 'Currentpoint'));
x = xy(1,1); y = xy(1,2);
%disp(['x = ', num2str(xy(1,1)), ' y = ', num2str(xy(1,2))]);
if handles.delete_mode == 1,
    ch = get(handles.axes1, 'Children'); 
    handles.Image((round(y)-1):(round(y)+1), (round(x)-1):(round(x)+1), :) = 0; 
    set(ch(1), 'CData', handles.Image);
end
guidata(hObject, handles)


% --- Executes on mouse press over figure background, over a disabled or
% --- inactive control, or over an axes background.
function figure1_WindowButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.delete_mode = 1;
set(handles.delete_mode_disp, 'string', 'Delete Mode ON');
handles.t = round(get(handles.T_slider, 'Value'));set(handles.T_slider, 'Value', handles.t);
handles.z = round(get(handles.Z_slider, 'Value'));set(handles.Z_slider, 'Value', handles.z);
handles.N_id = round(get(handles.N_slider, 'Value'));set(handles.N_slider, 'Value', handles.N_id);

BW_tmp = handles.BW_all{handles.t};

handles.Image = zeros(512,512,3);
handles.Image(:,:,1) = uint8(handles.Stack(:,:,handles.z)/256);
handles.Image(:,:,2) = (BW_tmp.L(:,:,handles.z) == BW_tmp.L_sort(handles.N_id))*1.0;


guidata(hObject, handles)


% --- Executes on mouse press over figure background, over a disabled or
% --- inactive control, or over an axes background.
function figure1_WindowButtonUpFcn(hObject, eventdata, handles)
handles.delete_mode = 0;
set(handles.delete_mode_disp, 'string', 'Delete Mode OFF');
handles.Stack(:,:,handles.z) = double(handles.Image(:,:,1)*256);
[L, Num] = bwlabeln(handles.Stack, 6);
BW_tmp.L = L;BW_tmp.Num = Num;
L_sizes = zeros(Num, 1);
L_non_zero = find(L ~= 0);
for i=1:length(L_non_zero),
    id = L(L_non_zero(i));
    L_sizes(id) = L_sizes(id) + 1;
end

[a, b] = sort(L_sizes);
a = flipud(a); b = flipud(b);

BW_tmp.L_sort = b;
BW_tmp.L_sizes = L_sizes;
handles.BW_all{handles.t} = BW_tmp;
handles.Stack_all{handles.t} = handles.Stack;

set(handles.N_slider, 'Min', 1);
set(handles.N_slider, 'Max', Num);
set(handles.N_slider, 'Value', handles.N_id);
set(handles.N_slider, 'SliderStep', [1/(Num-1) 10/(Num-1)]);
set(handles.N_disp, 'String', [num2str(handles.N_id), '/', num2str(Num)]);
set(handles.N_size, 'String', num2str(L_sizes(b(handles.N_id))));

delete(handles.hListener_1);
delete(handles.hListener_2);
handles.hListener_1 = addlistener(handles.N_slider, 'Value','PostSet', @(s, e) plot_things(handles));
handles.hListener_2 = addlistener(handles.Z_slider, 'Value','PostSet', @(s, e) plot_things(handles));

guidata(hObject, handles)
