close all;clear all;clc;
%load('Series008_with_Nucleus.mat');clear Nucleus_Pos_cell; clear Nucleus_All_traj;clear Nucleus_Data;clear Nucleus_Traj_sorted_data;
load('BEADS_DATA_12_16_Series001K');


%% Plot Trajectories between two time points
t1 = 1; t2 = t1 + 381;
figure('position', [50 50 700 700]), hold on,


T_traj_tmp = Sel_Traj_Len(Sel_Traj_T(T_traj, t1, t2), 20);
for i=1:length(T_traj_tmp),
    plot3(T_traj_tmp{i}(:, 1), T_traj_tmp{i}(:, 2), T_traj_tmp{i}(:, 3), 'r', 'linewidth', 1);
end
view([30 20]);
%%
%{
load('BEADS_DATA-Series002.mat');
Prop.dx = .410;
Prop.dy = .410;
Prop.dz = 2.0;
Prop.Zd = 26;
Prop.Td = 238;

for i=1:length(Pos_cell),
   P_tmp = Pos_cell{i};
   P_tmp(:, 1) = P_tmp(:, 1)*Prop.dx;
   P_tmp(:, 2) = P_tmp(:, 2)*Prop.dy;
   P_tmp(:, 3) = P_tmp(:, 3)*Prop.dz;
   Pos_cell{i} = P_tmp;
end

T_traj = Get_Trajectories(Pos_cell);

filename = '20111205-BEADS_DATA-Series002.mat';
save(filename, 'Prop', 'Pos_cell', 'T_traj');
%}
%%
load('Series008_Nucleus.mat');
%load('Beads_data_Pos_traj.mat');

%
T_end = 750;
Nucleus_Pos_cell = Nucleus_Pos_cell(1:T_end);
Nucleus_Direction = Nucleus_Direction(1:T_end);
Pos_cell = Pos_cell(1:T_end);

% Tracking the Nucleus
T_cell = Triangular_Trace(Nucleus_Pos_cell);

T_end = length(T_cell);
Tri_bool = cell(1, T_end);
for i=1:T_end,
   Tri_bool{i} = zeros(size(T_cell{i}, 1), 1); 
end

Traj_paint = 0;
N_traj = cell(1);
N_traj_D = cell(1);
for i=1:T_end,
   for j=1:length(T_cell{i}), 
        if Tri_bool{i}(j) == 0,
           % If we havent began picking the trajectory here then begin
           Traj_paint = Traj_paint + 1; step = i; cur_id = j;
           % take first position
           Traj_tmp = [Nucleus_Pos_cell{step}(T_cell{step}(cur_id, 1), :), step];
           Traj_tmp_Dir = [Nucleus_Direction{step}(T_cell{step}(cur_id, 1), :), step];
           while (step < (T_end-1)),
               Tri_bool{step}(cur_id) = Traj_paint;
               Traj_tmp = [Traj_tmp;[Nucleus_Pos_cell{step+1}(T_cell{step}(cur_id, 2), :), step+1]];
               Traj_tmp_Dir = [Traj_tmp_Dir;[Nucleus_Direction{step+1}(T_cell{step}(cur_id, 2), :), step+1]];
               % Then check whether the next step exists
               if sum(T_cell{step}(cur_id, 2) == T_cell{step+1}(:, 1)) > 0,
                     
                     cur_id = find(T_cell{step}(cur_id, 2) == T_cell{step+1}(:, 1), 1);
                     step = step + 1;
                     if Tri_bool{step}(cur_id) > 0,
                         break;
                     end
       
               else
                   break;
               end
           end
           N_traj{Traj_paint} = Traj_tmp;
           N_traj_D{Traj_paint} = Traj_tmp_Dir;
        end
   end
end

% Tracking the beads
T_traj = Get_Trajectories(Pos_cell);

%% Sort the trajectories from shortest to longest
Len_sort = zeros(size(T_traj));
Len_mat = zeros(length(T_traj), T_end);

for i=1:length(Len_sort),
    Len_sort(i) = size(T_traj{i}, 1);
    Len_mat(i, T_traj{i}(1,4):T_traj{i}(end,4)) = 1;
end

figure, plot(Len_sort);
figure, imagesc(Len_mat);

%% Sort the trajectories from shortest to longest
Len_sort = zeros(size(N_traj));
Len_mat = zeros(length(N_traj), T_end);

for i=1:length(Len_sort),
    Len_sort(i) = size(N_traj{i}, 1);
    Len_mat(i, N_traj{i}(1,4):N_traj{i}(end,4)) = 1;
end

figure, plot(Len_sort);
figure, imagesc(Len_mat);

%% For each time find the corresponding beads position for each nucleus
% Also get the Z and D with respect to the nucleus
Pos_cell_N = cell(length(Pos_cell));
Pos_cell_Z_D = cell(length(Pos_cell));
for i=1:length(Pos_cell),
    Pos_cell_N{i} = zeros(size(Pos_cell{i}, 1), 1);
    Pos_cell_Z_D{i} = zeros(size(Pos_cell{i}, 1), 2);
    % Get the position and orientation of the Nucleus
    for j=1:size(Pos_cell{i}, 1),
        % Get the current bead position
        R_mat = zeros(size(Nucleus_Pos_cell{i}, 1), 1);
        for k=1:size(Nucleus_Pos_cell{i}, 1),
           R_mat(k) = Dis_to_line(Nucleus_Pos_cell{i}(k, :), Nucleus_Direction{i}(k, :), Pos_cell{i}(j, :));
        end
        id = find(R_mat == min(R_mat));
        Pos_cell_N{i}(j) = id;
        D = R_mat(id);
        Z = sum((Pos_cell{i}(j, :) - Nucleus_Pos_cell{i}(id, :)).*(Nucleus_Direction{i}(id, :)));
        Pos_cell_Z_D{i}(j, 2) = D;
        Pos_cell_Z_D{i}(j, 1) = Z;
    end
    
end

% For each bead trajectory find the corresponding Nucleus
T_traj_N = cell(length(T_traj), 1);
figure('Position', [0 0 700 700]);
for i=1:length(T_traj),
    T_traj_N{i} = zeros(size(T_traj{i}, 1), 1);
    
    t_cur = T_traj{i}(1, 4);
   
    for j=1:size(T_traj{i}, 1),
        R_mat = [];R_id = [];
        for k=1:length(N_traj),
           t_tmp = find(N_traj{k}(:, 4) == t_cur);
           if ~isempty(t_tmp),
               R_id = [R_id;k];
               if length(t_tmp) > 1,
                   disp('ERRRRROR');break;
               end
               R_mat = [R_mat;Dis_to_line(N_traj{k}(t_tmp, 1:3), N_traj_D{k}(t_tmp, 1:3), T_traj{i}(j, 1:3))];
           end
        end
        id = find(R_mat == min(R_mat), 1);
        T_traj_N{i}(j) = R_id(id);
        t_cur = t_cur + 1;
    end
    disp(['Done Processing Traj number ', num2str(i)]);
    %hist(T_traj_N{i});drawnow;
    %pause(1);
    
    if size(T_traj_N{i}, 1) ~= size(T_traj{i}, 1),
       disp('ERROR');
       break;
    end
    
    
end

%% Put the corresponding trajectory into the Nucleus
N_traj_T = cell(length(N_traj), 1);

for i=1:length(N_traj),
    N_traj_T{i} = cell(1);
end

Len_min = 5;
for i=1:length(T_traj),
   T_tmp = T_traj_N{i};
   S = sort(T_tmp); D = [1;diff(S) ~= 0] == 1;
   N_id_tmp = S(D);
   
   for j=1:size(N_id_tmp),
      N_cell_tmp = N_traj_T{N_id_tmp(j)};count = length(N_cell_tmp);
      BW = (T_tmp == N_id_tmp(j));
      [BW_label, Num] = bwlabel(BW);
      
      for k=1:Num,
          Sel = (BW_label == k);
          if sum(Sel) >= Len_min,
              N_cell_tmp{count} = T_traj{i}(Sel, :); count = count + 1;
          end
      end
      N_traj_T{N_id_tmp(j)} = N_cell_tmp;  
      
   end
   disp(['Done Processing Traj number ', num2str(i)]); 
    
end

%% Transform the trajectories into Z and XY coordinates
Z_XY_traj = cell(1);count = 1;
Nucleus_Move = -3.5;
for i=1:length(N_traj_T),
    if size(N_traj{i}, 1) > 400,
        M = mean(N_traj{i}(100:300, 3));
        cut_id = min(find(N_traj{i}(:, 3) > (M + Nucleus_Move)));
        if ~isempty(cut_id),
            for j=1:length(N_traj_T{i}),
                if ~isempty(N_traj_T{i}{1})
                    B_o = N_traj_T{i}{j}(:, 1:3);
                    t_start = N_traj_T{i}{j}(1, 4); t_end = N_traj_T{i}{j}(end, 4);
                    t_start_id = find(N_traj{i}(:, 4) == t_start); t_end_id = find(N_traj{i}(:, 4) == t_end);
                    
                    N_o = N_traj{i}(t_start_id:t_end_id, 1:3);
                    N_d = N_traj_D{i}(t_start_id:t_end_id, 1:3);
                    
                    Z = sum((B_o - N_o).*N_d, 2);
                    XY = [];
                    for k=1:size(N_o, 1),
                        XY = [XY;Dis_to_line(N_o(k, :), N_d(k, :), B_o(k, :))];
                    end
                    T = (t_start:t_end)'; T = T - cut_id;
                    
                    Z_XY_traj{count} = [Z, XY, T]; count = count + 1;
                end
            end
        end
    end
end



%% Plot above
close all;
t = 100;
figure('Position', [0 100 700 600]), hold on;

scatter3(Pos_cell{t}(:, 1), Pos_cell{t}(:, 2), Pos_cell{t}(:, 3), 30, 'b', 'filled');
scatter3(Nucleus_Pos_cell{t}(:, 1), Nucleus_Pos_cell{t}(:, 2), Nucleus_Pos_cell{t}(:, 3), 60, 'r', 'filled');
beta = 15;
for i=1:size(Nucleus_Pos_cell{t}, 1),
   X = [Nucleus_Pos_cell{t}(i, 1) - beta*Nucleus_Direction{t}(i, 1), Nucleus_Pos_cell{t}(i, 1), Nucleus_Pos_cell{t}(i, 1) + beta*Nucleus_Direction{t}(i, 1)];
   Y = [Nucleus_Pos_cell{t}(i, 2) - beta*Nucleus_Direction{t}(i, 2), Nucleus_Pos_cell{t}(i, 2), Nucleus_Pos_cell{t}(i, 2) + beta*Nucleus_Direction{t}(i, 2)];
   Z = [Nucleus_Pos_cell{t}(i, 3) - beta*Nucleus_Direction{t}(i, 3), Nucleus_Pos_cell{t}(i, 3), Nucleus_Pos_cell{t}(i, 3) + beta*Nucleus_Direction{t}(i, 3)];
   plot3(X, Y, Z, 'k', 'linewidth', 3);
end

for i=1:size(Pos_cell{t}, 1),
   X = [Pos_cell{t}(i, 1) Nucleus_Pos_cell{t}(Pos_cell_N{t}(i), 1)];
   Y = [Pos_cell{t}(i, 2) Nucleus_Pos_cell{t}(Pos_cell_N{t}(i), 2)];
   Z = [Pos_cell{t}(i, 3) Nucleus_Pos_cell{t}(Pos_cell_N{t}(i), 3)];
   plot3(X, Y, Z, 'g', 'linewidth', 3);
end
view([-2 12]);

%% Check above

t = 55;
figure('Position', [0 0 700 700]), hold on;

N_P = [];N_D = [];
for i=1:length(N_traj),
   N_T = N_traj{i}(:, 4);
   t_tmp = find(N_T == t);
   if ~isempty(t_tmp),
     N_P = [N_P;N_traj{i}(t_tmp, 1:3)];
     N_D = [N_D;N_traj_D{i}(t_tmp, 1:3)];
   end
end

B_P = [];B_N = [];
for i=1:length(T_traj),
   B_T = T_traj{i}(:, 4);
   t_tmp = find(B_T == t);
   if length(t_tmp) > 1,
         disp('error');
   end
   
   if ~isempty(t_tmp),
     B_P = [B_P;T_traj{i}(t_tmp, 1:3)];
     t2_tmp = find(N_traj{T_traj_N{i}(t_tmp)}(:, 4) == t);
     if length(t2_tmp) < 1 || length(t2_tmp) > 1 ,
         disp('error');
         break;
     end
     B_N = [B_N;N_traj{T_traj_N{i}(t_tmp)}(t2_tmp, 1:3)];
   end
end

scatter3(N_P(:, 1), N_P(:, 2), N_P(:, 3), 60, 'r', 'filled');
scatter3(B_P(:, 1), B_P(:, 2), B_P(:, 3), 30, 'b', 'filled');
beta = 15;
for i=1:size(N_D, 1),
   X = [N_P(i, 1) - beta*N_D(i, 1), N_P(i, 1), N_P(i, 1) + beta*N_D(i, 1)];
   Y = [N_P(i, 2) - beta*N_D(i, 2), N_P(i, 2), N_P(i, 2) + beta*N_D(i, 2)];
   Z = [N_P(i, 3) - beta*N_D(i, 3), N_P(i, 3), N_P(i, 3) + beta*N_D(i, 3)];
   plot3(X, Y, Z, 'k', 'linewidth', 3);
end

for i=1:size(B_P, 1),
   X = [B_P(i, 1) B_N(i, 1)];
   Y = [B_P(i, 2) B_N(i, 2)];
   Z = [B_P(i, 3) B_N(i, 3)];
   plot3(X, Y, Z, 'g', 'linewidth', 3);
end

%% Plot the Z and XY trajectories
close all;
figure('Position', [0 0 700 700]), hold on;

for i=1:length(Z_XY_traj),
   scatter3(Z_XY_traj{i}(1, 2), Z_XY_traj{i}(1, 1), Z_XY_traj{i}(1, 3), 30, 'g', 'filled');
   plot3(Z_XY_traj{i}(:, 2), Z_XY_traj{i}(:, 1), Z_XY_traj{i}(:, 3), 'b', 'linewidth', 2);
   scatter3(Z_XY_traj{i}(end, 2), Z_XY_traj{i}(end, 1), Z_XY_traj{i}(end, 3), 30, 'r', 'filled');
end
plot3(zeros(600, 1), zeros(600, 1), [1:600]', 'r', 'linewidth', 5);
xlabel('XY');ylabel('Z');zlabel('Time');
view([-90 8]);

%% Plot the Z part of the Nucleus trajectory
%close all;
figure('Position', [0 0 700 700]), hold on;
Nucleus_Move = 3.5;count = 0;count2 = 0;
for i=1:length(N_traj),
    if size(N_traj{i}, 1) > 300,
        M = mean(N_traj{i}(100:300, 3));
        cut_id = min(find(N_traj{i}(:, 3) > (M + Nucleus_Move)));
        if ~isempty(cut_id),
            plot(N_traj{i}(:, 4) - cut_id, N_traj{i}(:, 3), 'r');count = count + 1;
            for j=1:length(N_traj_T{i}),
                if ~isempty(N_traj_T{i}{1}),
                    plot(N_traj_T{i}{j}(:, 4) - cut_id, N_traj_T{i}{j}(:, 3), 'b'); count2 = count2 + 1;
                end
            end
        end
    end
end
title(['Showing ', num2str(count), ' nuclei traj and ', num2str(count2), ' B traj']);; 

%% Put all the beads together

close all;
figure('Position', [0 0 700 700]);
numframes = 60*2;
The_Movie = moviein(numframes);
t_step = 5;
count = 1;

hold on;
for t=t_step:t_step:numframes*t_step,
    hold off;
    scatter(Pos_cell_Z_D{t}(:, 2), Pos_cell_Z_D{t}(:, 1), 'r', 'filled');
    axis([0 20 -50 50]);
    title(['Beads at t = ', num2str(t)]);
    drawnow; pause(.1);
    
    The_Movie(count, :) = getframe(figure(1));
    count = count + 1;
end
movie2avi(The_Movie, 'Beads Position WRT Nucleus.avi');

%% For each bead trajectory find the corresponding trajectory of the nucleus
% for each bead position find the closest nucleus
T_Nucleus_id = zeros(size(T_traj));

for i=1:length(T_traj),
   B_o = T_traj{i}(:, 1:3);
   T_v = T_traj{i}(:, 4);
   t1 = T_v(1);
   t2 = T_v(end);
   
   R_mat = [];id_mat = [];
   for j=1:length(N_traj),
       N_o = N_traj{j}(:, 1:3);
       N_v = N_traj_D{j}(:, 1:3);
       N_t = N_traj{j}(:, 4);
       t_1 = N_t(1); t_2 = N_t(end);
       
       if ~(t_1 > t2 || t_2 < t1),
           
           if t_2 > t2, t_2 = t2; end
           if t_1 < t1, t_1 = t1; end
           
           B_i_a = find(T_v == t_1); B_i_b = find(T_v == t_2);
           N_i_a = find(N_t == t_1); N_i_b = find(N_t == t_2);
           B_o_tmp = B_o(B_i_a:B_i_b, :);
           N_o_tmp = N_o(N_i_a:N_i_b, :);
           N_v_tmp = N_v(N_i_a:N_i_b, :);
           beta = repmat(sum(N_v_tmp.*(B_o_tmp - N_o_tmp), 2)./sqrt(sum(N_v_tmp.^2, 2)), 1, 3);       
           R_mat = [R_mat;mean(sqrt(sum((N_v_tmp.*beta + N_o_tmp - B_o_tmp).^2, 2)))]; %#ok<*AGROW>
           id_mat = [id_mat;j];
       end
       
   end
   
   if ~isempty(R_mat),
       [~, id] = min(R_mat);
       T_Nucleus_id(i) = id_mat(id);
   else
       T_Nucleus_id(i) = -1;
   end
    
    disp(['Done determining the closest nucleus trajectory for i = ', num2str(i)]);
end

% Now get the bead trajectories that are associated with each nucleus
N_traj_Beads = cell(size(N_traj));
for i=1:length(T_Nucleus_id),
    if T_Nucleus_id(i) > 0,
        N_traj_Beads{T_Nucleus_id(i)} = [N_traj_Beads{T_Nucleus_id(i)};i];
    end
end


%% For each nucleus tranform the position of the beads to its frame of reference
close all;
fig = figure('Position', [300 50 400 400]); hold on; % create the figure
count = 1;
Traj_Trans = cell(length(Nucleus_Pos_cell), 1);
Traj_Proc = cell(1);

for j=1:length(N_traj),
    N_P = N_traj{j}(:, 1:3);
    N_V = N_traj_D{j}(:, 1:3);
    N_T = N_traj{j}(:, 4);
    N_t_a = N_T(1); N_t_b = N_T(end);
    
    % If there are beads in the nucleus
    if ~isempty(N_traj_Beads{j}),
        % Then loop over the beads
        for i=1:length(N_traj_Beads{j}),
            B_P = T_traj{N_traj_Beads{j}(i)}(:, 1:3);
            B_T = T_traj{N_traj_Beads{j}(i)}(:, 4);
            
            % Now transform each trajectory to the coordinate frame tof the
            % beads
            B_t_a = B_T(1); B_t_b = B_T(end);
            
            if B_t_a < N_t_a, 
                t_cut_a = N_t_a; 
            else
                t_cut_a = B_t_a;
            end
            
            if B_t_b > N_t_b, 
                t_cut_b = N_t_b;
            else
                t_cut_b = B_t_b;
            end
            
            % Determine the selection indicies
            B_i_a = find(B_T == t_cut_a); B_i_b = find(B_T == t_cut_b);
            N_i_a = find(N_T == t_cut_a); N_i_b = find(N_T == t_cut_b);
            
            N_P_cut = N_P(N_i_a:N_i_b, :);N_V_cut = N_V(N_i_a:N_i_b, :);
            B_P_cut = B_P(B_i_a:B_i_b, :);
            
            AB = B_P_cut - N_P_cut;
            AC = N_V_cut - N_P_cut;
            
            Z = sum(AB.*AC, 2)./sqrt(sum(AC.*AC, 2));
            XY = sqrt(sum(AB.*AB, 2) - Z.^2);
            T = B_T(B_i_a:B_i_b);
            
            Traj_tmp = [];
            for t=1:length(T),
                Traj_Trans{T(t)} = [Traj_Trans{T(t)};[Z(t), XY(t)]];
                Traj_tmp = [Traj_tmp; [Z(t), XY(t), T(t)]];
            end
            Traj_Proc{count} = Traj_tmp;
            plot(T, Z, 'b', 'linewidth', 3);
            plot(T, XY, 'r', 'linewidth', 3);
            %plot(T, abs(XY), 'r', 'linewidth', 3);
            count = count + 1;
        end
    end
    
end
title(['Total of ', num2str(count), ' trajectories']);

%% Check
close all;
L_sizes = [0:1:100];
Len_V = zeros(size(L_sizes));
for i=1:length(L_sizes),
    Len_V(i) = length(Sel_Traj_Len(T_traj, L_sizes(i)));
end
figure, plot(L_sizes, Len_V);
%% HERE THE PROCESSING IS DONE AND THE FUN ANALYSIS BEGINS!!!!
%% Plot the beads and the nucleus at a particular time and show what beads connect to what
close all;

figure('Position', [0 0 700 700]); % create the figure
numframes = 60*2;
The_Movie = moviein(numframes); % Create the movie variable
%set(fig,'NextPlot','replacechildren');
count = 1;
t_step = 5; 
beta = 10;
hold on;
for t1=t_step:t_step:numframes*t_step,  

hold off;
     for i=1:length(N_traj),
        N_P = N_traj{i}(:, 1:3); N_P(:, 3) = -N_P(:, 3);
        N_D = N_traj_D{i}(:, 1:3); N_D(:, 3) = -N_D(:, 3);
        N_T = N_traj{i}(:, 4);
        if ~isempty(N_traj_Beads{i}),
            
            id = (N_T == t1);
            
            if sum(id) > 0,
                scatter3(N_P(id, 1), N_P(id, 2), N_P(id, 3), 60, 'r', 'filled');
                hold on;
                X = [[N_P(id, 1) - beta*N_D(id, 1)];[N_P(id, 1)];[N_P(id, 1) + beta*N_D(id, 1)]];
                Y = [[N_P(id, 2) - beta*N_D(id, 2)];[N_P(id, 2)];[N_P(id, 2) + beta*N_D(id, 2)]];
                Z = [[N_P(id, 3) - beta*N_D(id, 3)];[N_P(id, 3)];[N_P(id, 3) + beta*N_D(id, 3)]];
                plot3(X, Y, Z, 'k' ,'linewidth', 1);
            end
            
            for j=1:length(N_traj_Beads{i}),
                B_P = T_traj{N_traj_Beads{i}(j)}(:, 1:3); B_P(:, 3) = -B_P(:, 3);
                B_T = T_traj{N_traj_Beads{i}(j)}(:, 4);
                id2 = (B_T == t1);
                
                if sum(id2) > 0,
                    B_P_cut = B_P(id2, :);
                    scatter3(B_P_cut(:, 1), B_P_cut(:, 2), B_P_cut(:, 3), 30, 'b', 'filled');
                
                    for k=1:size(B_P_cut, 1),
                        plot3([B_P_cut(k, 1);N_P(id,1)], [B_P_cut(k, 2);N_P(id,2)], [B_P_cut(k, 3);N_P(id, 3)], 'g', 'linewidth', 2);
                    end
                end
            end
        end
    end
    view([79 14]);axis([0 Prop.Xd*Prop.dx 0 Prop.Yd*Prop.dy -Prop.Zd*Prop.dz 0]);
    title(['Nucleus and Beads at t = ', num2str(t1)]);
    drawnow; pause(.1);
    
    The_Movie(count, :) = getframe(figure(1));
    count = count + 1;
end
movie2avi(The_Movie, 'Nucleus_Beads_movie_1.avi');

%% Display the "Virtual Cell": Put all the nucleus at the origin
close all;

figure('Position', [0 0 700 700]); % create the figure
t_step = 10;
numframes = 600/t_step;
The_Movie = moviein(numframes); % Create the movie variable
%set(fig,'NextPlot','replacechildren');
count = 1;
Min_len = 20;
beta = 10;
hold on;
for t1=t_step:t_step:numframes*t_step,  

hold off;
     for i=1:length(N_traj),
        N_P = N_traj{i}(:, 1:3); N_P(:, 3) = -N_P(:, 3);
        N_P_mem = N_P; N_P = N_P - N_P;
        N_D = N_traj_D{i}(:, 1:3); N_D(:, 3) = -N_D(:, 3);
        N_T = N_traj{i}(:, 4);
        id = (N_T == t1);
        if ~isempty(N_traj_Beads{i}) && sum(id) > 0,
            
            
            
            
            scatter3(N_P(id, 1), N_P(id, 2), N_P(id, 3), 60, 'r', 'filled');
            hold on;
            X = [[N_P(id, 1) - beta*N_D(id, 1)];[N_P(id, 1)];[N_P(id, 1) + beta*N_D(id, 1)]];
            Y = [[N_P(id, 2) - beta*N_D(id, 2)];[N_P(id, 2)];[N_P(id, 2) + beta*N_D(id, 2)]];
            Z = [[N_P(id, 3) - beta*N_D(id, 3)];[N_P(id, 3)];[N_P(id, 3) + beta*N_D(id, 3)]];
            plot3(X, Y, Z, 'k' ,'linewidth', 1);
            
            
            
            for j=1:length(N_traj_Beads{i}),
                B_P = T_traj{N_traj_Beads{i}(j)}(:, 1:3); B_P(:, 3) = -B_P(:, 3);
                if size(B_P, 1) >= Min_len,
                    B_P = B_P - repmat(N_P_mem(id, :), size(B_P, 1), 1);
                    B_T = T_traj{N_traj_Beads{i}(j)}(:, 4);
                    id2 = (B_T == t1);
                    
                    if sum(id2) > 0,
                        B_P_cut = B_P(id2, :);
                        
                        scatter3(B_P_cut(:, 1), B_P_cut(:, 2), B_P_cut(:, 3), 30, 'b', 'filled');
                        hold on;
                        for k=1:size(B_P_cut, 1),
                            plot3([B_P_cut(k, 1);N_P(id,1)], [B_P_cut(k, 2);N_P(id,2)], [B_P_cut(k, 3);N_P(id, 3)], 'g', 'linewidth', 2);
                        end
                    end
                end
            end
        end
    end
    view([-94 10]);axis([-7 7 -7 7 -20 31]);
    title(['Nucleus and Beads at t = ', num2str(t1), ' with Min Length ', num2str(Min_len)]);
    drawnow; pause(.1);
    
    The_Movie(count, :) = getframe(figure(1));
    count = count + 1;
end
movie2avi(The_Movie, 'Nucleus_Beads_movie_1.avi');
   
%% Plot the beads and the nucleus at a particular time
t = 400;

figure('position', [0 0 700 700]), hold on,

scatter3(Nucleus_Pos_cell{t}(:, 1), Nucleus_Pos_cell{t}(:, 2), Nucleus_Pos_cell{t}(:, 3), 100, 'r', 'filled');
hold on;
beta = 10;
scatter3(Pos_cell{t}(:, 1), Pos_cell{t}(:, 2), Pos_cell{t}(:, 3), 100, 'b', 'filled');
for i=1:size(Nucleus_Pos_cell{t}, 1),
    X = [[Nucleus_Pos_cell{t}(i, 1) - beta*Nucleus_Direction{t}(i, 1)];Nucleus_Pos_cell{t}(i, 1);[Nucleus_Pos_cell{t}(i, 1) + beta*Nucleus_Direction{t}(i, 1)]];
    Y = [[Nucleus_Pos_cell{t}(i, 2) - beta*Nucleus_Direction{t}(i, 2)];Nucleus_Pos_cell{t}(i, 2);[Nucleus_Pos_cell{t}(i, 2) + beta*Nucleus_Direction{t}(i, 2)]];
    Z = [[Nucleus_Pos_cell{t}(i, 3) - beta*Nucleus_Direction{t}(i, 3)];Nucleus_Pos_cell{t}(i, 3);[Nucleus_Pos_cell{t}(i, 3) + beta*Nucleus_Direction{t}(i, 3)]];
    plot3(X, Y, Z, 'k', 'linewidth', 2);
end
   

%% Plot the a particular trajectory of a nucleus along with the trajectory of its corresponding beads
figure('position', [-1200 50 700 700]), hold on,
for j = 1:10,
if ~isempty(N_traj_Beads{j}),
    C = [1,0,0];
   plot3(N_traj{j}(:, 1), N_traj{j}(:, 2), N_traj{j}(:, 3), 'r', 'linewidth', 3);
   for i=1:length(N_traj_Beads{j}), 
      plot3(T_traj{N_traj_Beads{j}(i)}(:, 1), T_traj{N_traj_Beads{j}(i)}(:, 2), T_traj{N_traj_Beads{j}(i)}(:, 3), 'b', 'linewidth', 3);  
   end
end
   axis([0 Prop.Xd*Prop.dx 0 Prop.Yd*Prop.dy 0 Prop.Zd*Prop.dz]);
    view([9 4]);
end

%% Plot all the trajectories
close all;
figure('position', [-1200 50 700 700]), hold on,
for i=1:length(T_traj),
    plot3(T_traj{i}(:, 1), T_traj{i}(:, 2), T_traj{i}(:, 3), 'b');%, [1 0 0], 'linewidth', 3);
end
for i=1:length(N_traj),
    plot3(N_traj{i}(:, 1), N_traj{i}(:, 2), N_traj{i}(:, 3), 'r');%, [1 0 0], 'linewidth', 3);
end
   axis([0 Prop.Xd*Prop.dx 0 Prop.Yd*Prop.dy 0 Prop.Zd*Prop.dz]);
    view([9 4]);

%% Plot the z movement of each bead and nucleus
close all;
fig = figure('Position', [300 50 700 700]); % create the figure
numframes = 60*2;
Min_len = 20;
The_Movie = moviein(numframes); % Create the movie variable
set(fig,'NextPlot','replacechildren');
count = 1;
t_step = 5; 

for i=1:length(N_traj),
    if ~isempty(N_traj_Beads{i}) && size(N_traj{i}, 1) > Min_len,
        N_Z = N_traj{i}(:, 3);
        N_T = N_traj{i}(:, 4);
        none
        for j=1:length(N_traj_Beads{i}),
            B_Z = Traj_Proc{N_traj_Beads{i}(j)}(:, 1);
            if length(B_Z) >= Min_len,
                hold off;
                plot(N_T, N_Z, 'r', 'linewidth', 2);hold on;
                B_T = Traj_Proc{N_traj_Beads{i}(j)}(:, 3);
                plot(B_T, B_Z, 'b', 'linewidth', 2);
            end
        end
        title(['Beads of Nucleus = ' num2str(i), ' with ', num2str(length(N_traj_Beads{i})), ' bead trajectories']);
        drawnow; pause(.1);
        The_Movie(count, :) = getframe(figure(1));
        count = count + 1;
        
   end
end
movie2avi(The_Movie, 'All_Nuclei_and_Beads.avi');


%%
close all;
fig = figure('Position', [300 50 700 700]); % create the figure
numframes = 60*2;
The_Movie = moviein(numframes); % Create the movie variable
set(fig,'NextPlot','replacechildren');
count = 1;
t_step = 5; 
for t=t_step:t_step:numframes*t_step,
    t1 = t; t2 = t + 6*t_step;
    hold off;
    %scatter(Traj_Trans{t1}(:, 2), Traj_Trans{t1}(:, 1), 30, 'r', 'filled');hold on;
    %scatter(Traj_Trans{t2}(:, 2), Traj_Trans{t2}(:, 1), 30, 'g', 'filled');
    
    for i=1:length(Traj_Proc),
       B_P = Traj_Proc{i}(:, 1:2);
       B_T = Traj_Proc{i}(:, 3);
       B_t_a = B_T(1); B_t_b = B_T(end);
       
       Sel_id = (B_T >= t1) & (B_T <= t2);
       
       if sum(Sel_id) > 15
           B_sel = B_P(Sel_id, :);
           scatter(B_sel(1, 2), B_sel(1, 1), 30, 'r', 'filled');hold on;
           quiver(B_sel(1, 2), B_sel(1,1), B_sel(end, 2) - B_sel(1, 2), B_sel(end, 1) - B_sel(1, 1), 'b', 'linewidth', 2);
           %scatter(B_sel(end, 2), B_sel(end, 1), 30, 'g', 'filled');
           %plot(B_sel(:, 2), B_sel(:, 1), 'b', 'linewidth', 2);
       end
       
    end
    
    
    
    axis([0 30 -25 25]);
    title(['Beads at t = ' num2str(t)]);
    drawnow; pause(.1);
    
   
    The_Movie(count, :) = getframe(figure(1)); 
    count = count + 1;
end
movie2avi(The_Movie, 'Virtual_Cell.avi');

%% Plot Trajectories between two time points
t1 = 1; t2 = t1 + 500;
figure('position', [-1200 50 700 700]), hold on,
N_traj_tmp = Sel_Traj_Len(Sel_Traj_T(N_traj, t1, t2), 20);
for i=1:length(N_traj_tmp),
    plot3(N_traj_tmp{i}(:, 1), N_traj_tmp{i}(:, 2), N_traj_tmp{i}(:, 3), 'k', 'linewidth', 3);
end

T_traj_tmp = Sel_Traj_Len(Sel_Traj_T(T_traj, t1, t2), 20);
for i=1:length(T_traj_tmp),
    plot3(T_traj_tmp{i}(:, 1), T_traj_tmp{i}(:, 2), T_traj_tmp{i}(:, 3), 'r', 'linewidth', 3);
end

%% Create a movie
close all;
fig = figure('Position', [300 50 400 400]); % create the figure

numframes = 120;
The_Movie = moviein(numframes); % Create the movie variable
set(fig,'NextPlot','replacechildren');

t_step = 5;
count = 1;

for t = 1:t_step:(t_step*(numframes-1)),
    t1 = t;
    t2 = t+50;
    
    B_traj_cut = Sel_Traj_Len(Sel_Traj_T(T_traj, t1, t2), 10);
    N_traj_cut =  Sel_Traj_Len(Sel_Traj_T(N_traj, t1, t2), 10);
    
    figure(1), hold off;
    
    for i=1:length(B_traj_cut),
        scatter3(B_traj_cut{i}(1,1), B_traj_cut{i}(1,2), B_traj_cut{i}(1,3), 30, 'b', 'filled');
        hold on;
        scatter3(B_traj_cut{i}(end,1), B_traj_cut{i}(end,2), B_traj_cut{i}(end,3), 30, 'g', 'filled');
    end
    
    
    for i=1:length(N_traj_cut),
        scatter3(N_traj_cut{i}(1,1), N_traj_cut{i}(1,2), N_traj_cut{i}(1,3), 30, 'r', 'filled');
        scatter3(N_traj_cut{i}(end,1), N_traj_cut{i}(end,2), N_traj_cut{i}(end,3), 30, 'g', 'filled');
    end
    
    for i=1:length(B_traj_cut),
        plot3(B_traj_cut{i}(:, 1), B_traj_cut{i}(:, 2), B_traj_cut{i}(:, 3), 'b');
    end
    
    for i=1:length(N_traj_cut),
        plot3(N_traj_cut{i}(:, 1), N_traj_cut{i}(:, 2), N_traj_cut{i}(:, 3), 'r', 'linewidth', 3);
    end
    view([1 2]);axis([0 Prop.Xd*Prop.dx 0 Prop.Yd*Prop.dy 0 Prop.Zd*Prop.dz]);
    title(['Trajectories Between t = ', num2str(t1), ' and t = ', num2str(t2)]);
    drawnow; pause(.1);
   
    The_Movie(count, :) = getframe(figure(1)); 
    count = count + 1;
end
movie2avi(The_Movie, 'My_movie.avi');

%% Create a movie
close all;
fig = figure('Position', [300 50 620 620]); % create the figure

numframes = 500;
The_Movie = moviein(numframes); % Create the movie variable
set(fig,'NextPlot','replacechildren');

t_step = 5;
count = 1;
beta = 10;
for t = 100:numframes+100,
    scatter3(Nucleus_Pos_cell{t}(:, 1), Nucleus_Pos_cell{t}(:, 2), Nucleus_Pos_cell{t}(:, 3), 100, 'r', 'filled'); 
    hold on;
    scatter3(Pos_cell{t}(:, 1), Pos_cell{t}(:, 2), Pos_cell{t}(:, 3), 60, 'b', 'filled');
    for i=1:size(Nucleus_Pos_cell{t}, 1),
       X = [[Nucleus_Pos_cell{t}(i, 1) - beta*Nucleus_Direction{t}(i, 1)];Nucleus_Pos_cell{t}(i, 1);[Nucleus_Pos_cell{t}(i, 1) + beta*Nucleus_Direction{t}(i, 1)]];
       Y = [[Nucleus_Pos_cell{t}(i, 2) - beta*Nucleus_Direction{t}(i, 2)];Nucleus_Pos_cell{t}(i, 2);[Nucleus_Pos_cell{t}(i, 2) + beta*Nucleus_Direction{t}(i, 2)]];
       Z = [[Nucleus_Pos_cell{t}(i, 3) - beta*Nucleus_Direction{t}(i, 3)];Nucleus_Pos_cell{t}(i, 3);[Nucleus_Pos_cell{t}(i, 3) + beta*Nucleus_Direction{t}(i, 3)]];
        plot3(X, Y, Z, 'k', 'linewidth', 3);
    end
    hold off;
    
   axis([0 Prop.Xd*Prop.dx 0 Prop.Yd*Prop.dy 0 Prop.Zd*Prop.dz]);
    view([9 4]);

    title(['Nucleus at t = ', num2str(t)]);
    drawnow; pause(.1);
   
    The_Movie(count, :) = getframe(figure(1)); 
    count = count + 1;
end
movie2avi(The_Movie, 'My_movie.avi');



