clear all;clc;
%
Z_max = 24; T_max = 125;
imfile = [pwd, '\K_DATA\val007_BW.tif'];
outfile = [pwd, '\K_DATA\test.tif'];
im_tmp = imread(imfile, 1);
count = 1;
S = zeros(size(im_tmp, 1), size(im_tmp, 2), Z_max);


for i=1:24,
    im_tmp = imread(imfile,i);
    S(:,:,i) = double(im_tmp);
end
S_new = Hessian_Filter(S, 12);


for i=1:size(S_new, 3),
    if count == 1,
        imwrite(S_new(:,:,i), outfile, 'tif');
    else
        imwrite(S_new(:,:,i), outfile, 'tif', 'writemode', 'append');
    end
    count = count + 1;
end
    
%%
S_tmp = S(:,:,15);
G = fspecial('gaussian', 10);
F = imfilter(S_tmp, G);
image(F);

Fxx = 2*F(2:(end-1), (2:(end-1))) - F(1:(end-2), (2:(end-1))) - F(3:end, (2:(end-1)));
Fyy = 2*F(2:(end-1), (2:(end-1))) - F(2:(end-1), (1:(end-2))) - F(2:(end-1), (3:end));

F_neg = ((Fxx + Fyy) < 0);

S_tmp = S_tmp(2:(end-1), (2:(end-1)));
F_tmp = bwmorph(F_neg, 'close', 1);

im = zeros(size(S_tmp,1), size(S_tmp,1), 3);
im(:,:,1) = S_tmp/256;
im(:,:,2) = F_tmp;

%figure, image(S_tmp.*(~F_tmp));
figure, image(S_tmp);
%imagesc(F_tmp);



%%
Sxx = 2*S(2:(end-1),2:(end-1),2:(end-1)) - ...
    S(1:(end-2),2:(end-1),2:(end-1)) - S(3:end,2:(end-1),2:(end-1));

Syy = 2*S(2:(end-1),2:(end-1),2:(end-1)) - ...
    S(2:(end-1),1:(end-2),2:(end-1)) - S(2:(end-1),3:end,2:(end-1));

Szz = 2*S(2:(end-1),2:(end-1),2:(end-1)) - ...
    S(2:(end-1),2:(end-1),1:(end-2)) - S(2:(end-1),2:(end-1),3:end);

C = Sxx + Syy + Szz;
C_pos = (C > 0)*255;
C_neg = (C < 0)*255;

%%
[BW_L, n] = bwlabeln(S);
image(BW_L(:,:,2)), axis off;

Pix_sum = zeros(1, n);
BW_new = BW_L;
Thresh = 300;
for i=1:n,
    Pix_sum(i) = sum(sum(sum(BW_L == i)));
    if Pix_sum(i) <= Thresh,
        BW_new(BW_new == i) = 0;
        Pix_sum(i) = 0;
    end
end
%%
outfile = [pwd, '\K_DATA\outfile.tif'];
imwrite(uint8(BW_new(:,:,1)), outfile, 'tif');
for i=2:Z_max,
    imwrite(uint8(BW_new(:,:,i)), outfile, 'tif', 'writemode', 'append');
end


%%
tic,

    L_sizes = zeros(Num, 1);
    K = find(L ~= 0);
    
    for i=1:length(K),
        id = L(K(i));
        L_sizes(id) = L_sizes(id) + 1;
    end
    
toc  
    
    %%
tic,
    L_sizes = zeros(Num, 1);
    for i=1:512,
        for j=1:512,
            for k=1:24,
                if L(i,j,k) == 0 continue, end
                id = L(i,j,k);
                L_sizes(id) = L_sizes(id) + 1;
            end
        end
    end
toc
%%
    [a, b] = sort(L_sizes);
    a = flipud(a); b = flipud(b);
    %%L_sizes = a;
K = find(L ~= 0);
tic,
tmp = 1:length(b);
for i=1:length(K),
    L(K(i)) = find(b == L(K(i)));
    %L(K(i)) = tmp(b == L(K(i)));
end
toc;
%%
Num = 270;
tic,
L_sizes = zeros(Num, 1);
for k=1:Num,
    L_sizes(k) = sum(sum(sum(L == k)));
end
toc




